/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2013 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/

var Reporters = function()
{
	var reporters = {};
	
	/**
		Initialize the page.
	*/
	reporters.initPage = function()
	{
		var attributes = {'item-type': 'REPORTER'};
		var tableAttributes = {'table-id': 'reporters'};
		Buttons.addClickHandler('btnColumns', Buttons.configureColumns, tableAttributes);
		Buttons.addClickHandler('btnExport', Buttons.runListPlugin, tableAttributes);
		Buttons.addClickHandler('btnNewReporterList', reporters.newReporterList);
		Buttons.addClickHandler('btnUpdateClonedReporters', reporters.updateClonedReporters);
		Buttons.addClickHandler('btnRemoveClonedReporters', reporters.removeClonedReporters);

		Buttons.addClickHandler('close', App.closeWindow);
		Buttons.addClickHandler('btnOk', Buttons.returnSelected, tableAttributes);

		TabControl.setSwitchFunction('main', reporters.switchTab);
	}
	
	reporters.newReporterList = function()
	{
		var controller = Items.getController('REPORTERLIST');
		Table.submitToPopup('reporters', 'CreateReporterList', controller.width, controller.height);
	}

	
	reporters.switchTab = function(event)
	{
		var target = event.target;
		var tabId = target.id.substring(5);

		var frm = document.forms['reporters'];
		var experimentId = frm.experiment_id.value;

		var url;
		if (tabId == 'bioassaysets')
		{
			url = '../bioassaysets/index.jsp?ID='+App.getSessionId();
			url += '&experiment_id='+experimentId;
		}
		else
		{
			url = '../index.jsp?ID='+App.getSessionId();
			url += '&cmd=ViewItem&item_id='+experimentId;
			url += '&tab='+tabId;
		}
		location.replace(url);
	}


	reporters.removeClonedReporters = function()
	{
		if (confirm('Are you sure that you want to remove all cloned reporter annotations?\nThis action can\'t be undone.'))
		{
			var url = '../index.jsp?ID='+App.getSessionId();
			url += '&cmd=RemoveClonedReporters&item_id='+experimentId;
			Dialogs.openPopup(url, 'RemoveClonedReporters', 450, 300);
		}
	}
	
	reporters.updateClonedReporters = function()
	{
		var frm = document.forms['reporters'];
		var experimentId = frm.experiment_id.value;
		var url = 'index.jsp?ID='+App.getSessionId();
		url += '&cmd=UpdateClonedReporters&experiment_id='+experimentId;
		Dialogs.openPopup(url, 'UpdateClonedReporters', 600, 400);
	}

	
	return reporters;
}();

Doc.onLoad(Reporters.initPage);

