<%-- $Id: view_experiment.jsp 6605 2014-11-18 12:48:42Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson, Gregory Vincic
	Copyright (C) 2007 Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@page import="org.json.simple.JSONObject"%>
<%@page import="org.json.simple.JSONArray"%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.VirtualDb"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.Annotatable"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.VirtualTable"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.ChangeHistoryUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.snapshot.SnapshotManager"
	import="net.sf.basedb.core.snapshot.AnnotationSetSnapshot"
	import="net.sf.basedb.core.snapshot.AnnotationSnapshot"
	import="net.sf.basedb.core.snapshot.AnnotationTypeFilter"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Collections"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.HashMap"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.List"
	import="java.util.LinkedList"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.EXPERIMENT;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getString(request.getParameter("tab"), "properties");
final float scale = Base.getScale(sc);
final String root = request.getContextPath();
final DbControl dc = sc.newDbControl();
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	Experiment experiment = Experiment.getById(dc, itemId);
	VirtualDb virtualDb = experiment.getVirtualDb();
	
	final boolean writePermission = experiment.hasPermission(Permission.WRITE);
	final boolean deletePermission = experiment.hasPermission(Permission.DELETE);
	final boolean sharePermission = experiment.hasPermission(Permission.SET_PERMISSION);
	final boolean setOwnerPermission = experiment.hasPermission(Permission.SET_OWNER);
	final boolean isOwner = experiment.isOwner();
	final boolean isRemoved = experiment.isRemoved();
	final boolean isUsed = isRemoved && experiment.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	
	Map<AnnotationType, Set<Object>> usedFactorValues = 
		new HashMap<AnnotationType, Set<Object>>();
	Map<AnnotationType, Integer> factorValuesCount = new HashMap<AnnotationType, Integer>();
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, experiment);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>" id="view-page">
	<base:head scripts="table.js,tabcontrol-2.js,~experiments.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<p:path><p:pathelement 
			title="Experiments" href="<%="index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(experiment.getName())%>" 
			/></p:path>
		<div id="page-data" data-item-id="<%=itemId%>"></div>
		
		<t:tabcontrol 
			id="main" 
			subclass="content mastertabcontrol" 
			active="<%=tab%>" remember="false">
		<t:tab id="properties" title="Properties">
			<div>
			<table class="fullform">
			<tr>
				<th class="itemstatus">
					<base:icon 
						image="shared.png" 
						visible="<%=experiment.isShared()%>"
						tooltip="This item is shared to other users, groups and/or projects"
					/>
					<base:icon 
						id="btnDeletePermanently"
						image="deleted.png"
						tooltip="This item has been flagged for deletion. Click to delete it now."
						enabled="<%=deletePermanentlyPermission %>"
						visible="<%=isRemoved%>" 
					/>
					<base:icon
						id="btnUsingItems"
						image="used.png" 
						tooltip="This item is used by other items and can't be permanently deleted. Show the items that are using this one"
						visible="<%=isRemoved && isUsed%>" />
				</th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder bg-filled-50">
						<tbl:button 
							id="btnEdit"
							disabled="<%=!writePermission%>" 
							image="edit.png" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this experiment" : "You do not have permission to edit this experiment"%>" 
						/>
						<tbl:button 
							id="btnDelete"
							disabled="<%=!deletePermission%>" 
							image="delete.png" 
							title="Delete"
							visible="<%=!experiment.isRemoved()%>"
							tooltip="<%=deletePermission ? "Delete this experiment" : "You do not have permission to delete this experiment"%>" 
						/>
						<tbl:button 
							id="btnRestore"
							disabled="<%=!writePermission%>" 
							image="restore.png" 
							title="Restore"
							visible="<%=experiment.isRemoved()%>"
							tooltip="<%=writePermission ? "Restore this experiment" : "You do not have permission to restore this experiment"%>" 
						/>
						<tbl:button 
							id="btnShare"
							disabled="<%=!sharePermission%>"
							image="share.png"
							title="Share&hellip;" 
							tooltip="<%=sharePermission ? "Share this experiment to other user, groups and projects" : "You do not have permission to share this experiment"%>"
						/>
						<tbl:button 
							id="btnSetOwner"
							disabled="<%=!setOwnerPermission%>"
							image="take_ownership.png"
							title="Set owner&hellip;"
							tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
						/>
						<tbl:button
							id="btnCloneReporters"
							visible="<%=writePermission && (virtualDb.hasTable(VirtualTable.POSITION) || experiment.getRawDataType().isStoredInDb()) %>"
							image="copy.png"
							title="Clone reporters&hellip;"
							tooltip="Clone reporter annotations for all reporters that are used in this experiment"
						/>
						<tbl:button
							id="btnRemoveClonedReporters"
							visible="<%=writePermission && virtualDb.hasClonedReporters() %>"
							image="delete_permanently.png"
							title="Remove cloned reporters&hellip;"
							tooltip="Remove all cloned reporter annotations"
						/>
						<tbl:button 
							id="btnImport"
							image="import.png" 
							data-plugin-type="IMPORT"  
							title="Import&hellip;" 
							tooltip="Import data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
						/>
						<tbl:button 
							id="btnExport"
							image="export.png"
							data-plugin-type="EXPORT" 
							title="Export&hellip;" 
							tooltip="Export data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
						/>
						<tbl:button 
							id="btnRunPlugin"
							image="runplugin.png"  
							data-plugin-type="OTHER" 
							title="Run plugin&hellip;" 
							tooltip="Run a plugin" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
						/>
						<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
						<tbl:button
							image="help.png"
							subclass="auto-init"
							data-auto-init="help"
							data-help-id="experiment.view.properties"
							title="Help&hellip;"
							tooltip="Get help about this page"
						/>
					</tbl:toolbar>
				</td>
			</tr>
		</table>
		<table style="width: 100%; height: 16em;" class="bottomborder">
		<tr>
			<td style="width: 50%; height: 100%;">
				<table class="fullform" >
				<tr>
					<th>Name</th>
					<td><%=HTML.encodeTags(experiment.getName())%></td>
				</tr>
				<tr>
					<th>Registered</th>
					<td><%=dateFormatter.format(experiment.getEntryDate())%></td>
				</tr>
				<tr>
					<th>Raw data type</th>
					<td><base:catch><%=HTML.encodeTags(experiment.getRawDataType().getName())%></base:catch></td>
				</tr>
				<tr>
					<th>Directory</th>
					<td><base:propertyvalue item="<%=experiment%>" property="directory" /></td>
				</tr>
				<tr>
					<th>Reporter clone template</th>
					<td><base:propertyvalue item="<%=experiment%>" property="virtualDb.reporterCloneTemplate" nulltext="<i>- no cloned reporters -</i>" /></td>
				</tr>
				<tr>
					<th>Bytes</th>
					<td><%=Values.formatBytes(experiment.getBytes())%></td>
				</tr>
				<tr>
					<th>Owner</th>
					<td><base:propertyvalue item="<%=experiment%>" property="owner" /></td>
				</tr>
				<tr>
					<th>Permissions</th>
					<td><%=PermissionUtil.getFullPermissionNames(experiment)%></td>
				</tr>
				<tr class="dynamic">
					<th>Description</th>
					<td><%=HTML.niceFormat(experiment.getDescription())%></td>
				</tr>
				</table>
			</td>
			<td style="width: 50%; height: 100%;" class="leftborder">
				<table class="fullform">
				<tr>
					<th>PubMed ID</th>
					<td>
						<%=HTML.encodeTags(experiment.getPubMedId())%>
						<%
						int pubMedId = Values.getInt(experiment.getPubMedId(), -1);
						if (pubMedId != -1)
						{
							%>
							<b>Link to:</b>
							<a href="http://www.ebi.ac.uk/citexplore/citationDetails.do?externalId=<%=pubMedId%>&dataSource=MED"
								target="_blank" title="External link to EBI Citation database"
								>EBI Citation database</a>,
							<a href="http://www.ncbi.nlm.nih.gov/entrez/query.fcgi?cmd=PureSearch&db=pubmed&details_term=<%=pubMedId%>"
								target="_blank" title="External link to NCBI Entrez PubMed">NCBI Entrez PubMed</a>
							<%
						}
						%>
					</td>
				</tr>
				<tr>
					<th>Title</th>
					<td><%=HTML.niceFormat(experiment.getTitle())%></td>
				</tr>
				<tr>
					<th>Publication date</th>
					<td><%=dateFormatter.format(experiment.getPublicationDate())%></td>
				</tr>
				<tr>
					<th>Abstract</th>
					<td><%=HTML.niceFormat(experiment.getAbstract())%></td>
				</tr>
				<tr>
					<th>Experiment design</th>
					<td><%=HTML.niceFormat(experiment.getExperimentDesign())%></td>
				</tr>
				<tr>
					<th>Experiment type</th>
					<td><%=HTML.niceFormat(experiment.getExperimentType())%></td>
				</tr>
				<tr>
					<th>Affiliations</th>
					<td><%=HTML.niceFormat(experiment.getAffiliations())%></td>
				</tr>
				<tr>
					<th>Authors</th>
					<td><%=HTML.niceFormat(experiment.getAuthors())%></td>
				</tr>
				<tr class="dynamic">
					<th>Publication</th>
					<td><%=HTML.niceFormat(experiment.getPublication())%></td>
				</tr>
				</table>
			</td>
		</tr>
		</table>
		</div>
			
			<%
			ItemQuery<AnnotationType> efQuery = experiment.getExperimentalFactors();
			efQuery.include(Include.ALL);
			efQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<AnnotationType> experimentalFactors = efQuery.list(dc);
			%>
			<base:section 
				id="experimentalFactors" 
				title="<%="Experimental factors (" + experimentalFactors.size() +")"%>"
				context="<%=cc%>"
				>
				<%
				if (experimentalFactors.size() == 0)
				{
					%>
					<div class="messagecontainer note">
					No experimental factors has been added to this experiment 
					(or, you don't have permission to view them).
					</div>
					<%
				}
				else
				{
					%>
					<div style="width: 100%; max-width: 1000px;">
					<tbl:table
						id="tbl.experimentalFactors"
						columns="all"
						action="index.jsp"
						>
						<tbl:hidden name="item_id" value="<%=Integer.toString(itemId)%>" />
						<tbl:columndef 
							id="name"
							title="Name"
						/>
						<tbl:columndef
							id="type"
							title="Value type"
						/>
						<tbl:columndef
							id="values"
							title="Used values"
						/>
						<tbl:columndef 
							id="description"
							title="Description"
						/>
						<tbl:columndef 
							id="status"
							title="Status"
						/>
						<tbl:data>
							<tbl:headers>
								<tbl:headerrow>
									<tbl:columnheaders />
								</tbl:headerrow>
							</tbl:headers>
							<tbl:rows>
							<%
							for (AnnotationType item : experimentalFactors)
							{
								Type valueType = item.getValueType();
								usedFactorValues.put(item, new HashSet<Object>());
								factorValuesCount.put(item, 0);
								Formatter formatter = FormatterFactory.getTypeFormatter(sc, valueType);
								%>
								<tbl:row>
									<tbl:cell column="name"><base:icon 
											image="deleted.png" 
											tooltip="This item has been scheduled for deletion" 
											visible="<%=item.isRemoved()%>"
										/><%=Base.getLinkedName(ID, item, false, true)%></tbl:cell>
									<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
									<tbl:cell column="type">
										<%=valueType%>
										<%=item.isEnumeration() ? "(enumeration)" : ""%>
									</tbl:cell>
									<tbl:cell column="values">
										<%
										if (!item.isEnumeration() && (valueType == Type.TEXT || valueType == Type.STRING))
										{
											%>
											N/A
											<%
										}
										else
										{
											%>
											<div id="usedvalues.<%=item.getId()%>">Loading...</div>
											<%
										}
										%>
									</tbl:cell>
									<tbl:cell column="status" id="<%="status." + item.getId()%>">
									</tbl:cell>
								</tbl:row>
								<%
							}
							%>
							</tbl:rows>
						</tbl:data>
					</tbl:table>
					<div id="warning.missing" style="display: none; text-align: right;">
						<base:icon image="warning.png" /> = Some raw bioassays are missing this factor value
					</div>
				</div>
				<%
				}
				%>
			</base:section>
			<%
			ItemQuery<RawBioAssay> rbaQuery = experiment.getRawBioAssays();
			rbaQuery.include(Include.ALL);
			rbaQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<RawBioAssay> rawBioAssays = rbaQuery.list(dc);
			%>
			<base:section 
				id="rawbioassays" 
				title="<%="Raw bioassays (" + rawBioAssays.size() +")"%>"
				context="<%=cc%>">
				<%
				if (rawBioAssays.size() == 0)
				{
					%>
					<div class="messagecontainer note">
					No raw bioassays has been added to this experiment 
					(or, you don't have permission to view them).
					</div>
					<%
				}
				else
				{
					%>
					<tbl:table
						id="tbl.rawbioassays"
						columns="all"
						>
					<tbl:columndef 
						id="name"
						title="Name"
					/>
					<tbl:columndef 
						id="description"
						title="Description"
					/>
					<%
					for (AnnotationType at : experimentalFactors)
					{
						Formatter formatter = FormatterFactory.getTypeFormatter(sc, at.getValueType());
						%>
						<tbl:columndef
							id="<%="at"+at.getId()%>"
							title="<%=HTML.encodeTags(at.getName())%>"
							formatter="<%=formatter%>"
						/>
						<%
					}
					%>
					<tbl:data>
						<tbl:headers>
							<tbl:headerrow>
								<tbl:columnheaders />
							</tbl:headerrow>
						</tbl:headers>
						<tbl:rows>
						<%
						SnapshotManager manager = new SnapshotManager();
						AnnotationTypeFilter annotationTypeFilter = new AnnotationTypeFilter();
						for (RawBioAssay item : rawBioAssays)
						{
							AnnotationSet as = item.isAnnotated() ? item.getAnnotationSet() : null;
							AnnotationSetSnapshot snapshot = as == null ? null : manager.getSnapshot(dc, as.getId());
							%>
							<tbl:row>
								<tbl:cell column="name"><base:icon 
										image="deleted.png" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=item.isRemoved()%>"
									/><%=Base.getLinkedName(ID, item, false, true)%></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
								<%
								for (AnnotationType at : experimentalFactors)
								{
									Unit unit = at.getDefaultUnit();
									String unitSymbol = unit == null ? "" : "&nbsp;" + unit.getDisplaySymbol();
									
									String value = "<i>- none -</i>";
									annotationTypeFilter.setAnnotationType(at);
									List<AnnotationSnapshot> all = snapshot == null ? 
											null : manager.findAnnotations(dc, snapshot, annotationTypeFilter, true);
									Map<Annotatable, List> factorValues = new HashMap<Annotatable, List>();
									if (all != null && all.size() > 0)
									{
										for (AnnotationSnapshot a : all)
										{
											List values = a.getValues();
											usedFactorValues.get(at).addAll(values);
											factorValuesCount.put(at, factorValuesCount.get(at)+1);
											Annotatable aItem = null;
											try
											{
												aItem = a.getItem(dc);
											}
											catch (Throwable t)
											{}
											List toAdd = factorValues.get(aItem);
											if (toAdd == null)
											{
												toAdd = new LinkedList();
												factorValues.put(aItem, toAdd);
											}
											toAdd.addAll(values);
										}
									}
									%>
									<tbl:cell column="<%="at"+at.getId()%>">
										<%
										for (Map.Entry<Annotatable, List> entry : factorValues.entrySet())
										{
											Annotatable aItem = entry.getKey();
											List values = entry.getValue();
											%>
											<tbl:cellvalue list="<%=values%>" suffix="<%=unitSymbol%>"/>
											<%
											if (aItem != null && aItem.hasPermission(Permission.WRITE))
											{
												%>: <base:icon 
														subclass="link auto-init"
														data-auto-init="edit-experimental-factor"
														data-item-type="<%=aItem.getType().name()%>"
														data-item-id="<%=aItem.getId() %>"
														data-annotation-type="<%=at.getId() %>"
														image="edit.png" 
														tooltip="Modify the values of this experimental factor"
													/>
												<%
											}
										}
										%>
									</tbl:cell>
									<%
								}
								%>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
				</tbl:table>
				<%
			}
			%>
			</base:section>
			<jsp:include page="../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this experiment" />
			</jsp:include>
			<jsp:include page="../../common/share/list_share.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Shared to" />
			</jsp:include>
		
				<%
				JSONArray jsonFactorValues = new JSONArray();
				for (Map.Entry<AnnotationType, Set<Object>> entry : usedFactorValues.entrySet())
				{
					AnnotationType at = entry.getKey();
					
					JSONObject jsonAt = new JSONObject();
					jsonAt.put("id", at.getId());
					jsonAt.put("numRawBioAssaysWithFactor", factorValuesCount.get(at));

					Type valueType = at.getValueType();
					if (at.isEnumeration() || (valueType != Type.TEXT && valueType != Type.STRING))
					{
						Set<Object> values = entry.getValue();
						Formatter formatter = FormatterFactory.getTypeFormatter(sc, valueType);
						Unit unit = at.getDefaultUnit();
						if (unit != null) formatter = unit.getFormatter(formatter);
						String formattedValues = HTML.encodeTags(Values.getString(values, ", ", true, formatter));
						jsonAt.put("usedValues", formattedValues);
					}
					
					jsonFactorValues.add(jsonAt);
				}
				%>
				<div id="factor-values" class="datacontainer"
					data-num-raw-bioassays="<%=rawBioAssays.size() %>"
					data-factor-values="<%=HTML.encodeTags(jsonFactorValues.toJSONString()) %>"
				></div>

			</t:tab>
			<t:tab id="annotations" title="Annotations" 
				tooltip="View annotation values" clazz="white">
				<jsp:include page="../../common/annotations/list_frameset.jsp">
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
			</t:tab>
			
			<t:tab id="bioassaysets" title="Bioassay sets" />
			<t:tab id="clonedreporters" 
				title="Cloned reporters" 
				visible="<%=virtualDb.hasClonedReporters() %>"
				tooltip="Show information about cloned reporters"
			/>
			<t:tab id="overview" title="Overview" 
				tooltip="Display a tree overview of related items">
				<jsp:include page="../../common/overview/overview.jsp">
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
			</t:tab>			
			<t:tab id="history" title="Change history" 
				tooltip="Displays a log of all modifications made to this item"
				visible="<%=ChangeHistoryUtil.showChangeHistoryTab(sc)%>">
				<jsp:include page="../../common/history/frameset.jsp">
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
			</t:tab>
			</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
